/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) 2001 by Karl E. Maij
    email              : kem@sitedesign.ch
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.	See http://www.gnu.org		
****************************************************************************/

#include "kppics.h"
#include "kpass.h"
#include "kpass.moc"
#include "kpopt.h"
#include "kppwd.h"
#include "kpgrp.h"
#include "kpout.h"




// global config data
int pwdGeneratorValue;
bool isPasswdChecked;
bool isInfoMsgChecked;
bool isShowTipChecked;
bool isEncryptChecked;
bool isEditMaskChecked;
bool isBrowserChecked;
bool isBrowserLogin;
bool isFtpLogin;
bool isEdit;
QString whatPassword;
QString progBrowserName;
QString progFtpName;
QString filePath;
// key where groups are stored
QString groupConfMain = "Groups";
// protocol and url for password item
static QString urlProtocol;
static QString urlString;
// where the data are stored
static QString dataFileName = "kpass.dat";
static QString dataDirName = ".kpass";
static QPoint mainWinPos;


Kpass::Kpass( KMainWindow* parent,  const char* name, WFlags fl ) : KMainWindow( parent, name, fl ){

  getConfig();
  getFileDir();
  setupMainWindow();
	setConfig();
}

Kpass::~Kpass(){}


// if no directory and basefile exists, the programm will make it
void Kpass::getFileDir(){
	QString homeDir = QDir::homeDirPath();
	filePath = homeDir+"/"+dataDirName+"/"+dataFileName;
	QString mainDir = homeDir+"/"+dataDirName;
	QFileInfo dirExists ( mainDir );
	if( ! dirExists.exists() ){	
  	KMessageBox::information( this, i18n(
		"Hello,\nit seems this is the first start of Kpass.\n\n"
		"To get the program work properly, a \ndirectory to store the datafile is needed!\n\n"
		"The program will create it now for you\nHave fun :)") );	
    // make dir for datafile
    QDir tmp;
		tmp.mkdir( mainDir );
		// check if dir is there
		QFileInfo dirNewExists ( mainDir );
		if( ! dirNewExists.exists() ){	
			QMessageBox::warning( this, "error", i18n(
			"Directory and file are not created!\nThe program will not save any input!!!\n\n"
			"Please Check Permissions.") );
    }else{
			KMessageBox::information( this, i18n(
			"Directory and file created!")+QString( "\n\n" )+i18n(
			"Your data file will be stored under\n"+filePath+
			"\nYou can use backup function to care\nfor your data.\n\nHave a nice day.") );
		}
	}
}


// and here comes the main widget where users work with
void Kpass::setupMainWindow(){

  QPixmap image0( ( const char** ) image0_data );
  QPixmap image1( ( const char** ) image1_data );
  QPixmap image2( ( const char** ) image2_data );
  QPixmap image3( ( const char** ) image3_data );
  QPixmap image4( ( const char** ) image4_data );
  QPixmap image5( ( const char** ) image5_data );
	this->setFixedSize( 455, 430 );

	// the menubar
	QPopupMenu *filePopup = new QPopupMenu(this);
	KAction *groupAction = new KAction( i18n( "New &Group" ),"folder_open",Qt::CTRL + Qt::Key_G ,this, SLOT (openNewGroupWin() ), actionCollection() );
	groupAction->plug ( filePopup );
	KAction *passwordAction = new KAction( i18n( "New &Password" ),"document",Qt::CTRL + Qt::Key_P ,this, SLOT (pwdNewMask() ), actionCollection() );
	passwordAction->plug ( filePopup );
	KAction *backupAction = new KAction( i18n( "&Backup" ), image3,Qt::CTRL + Qt::Key_B ,this, SLOT (openBackup() ), actionCollection() );
	backupAction->plug ( filePopup );
	KAction *optAction = new KAction( i18n( "&Options" ), image5,Qt::CTRL + Qt::Key_O ,this, SLOT (openOptions() ), actionCollection() );
	optAction->plug ( filePopup );
	KAction *printOptAction = new KAction( i18n( "P&rint Options" ), image4,Qt::CTRL + Qt::Key_R ,this, SLOT (openPrinter() ), actionCollection() );
	printOptAction->plug ( filePopup );
	KAction *quitAction = KStdAction::quit(this, SLOT (appQuit() ), actionCollection() );
	quitAction->plug ( filePopup );

	menuBar()->insertItem ( i18n( "&Program" ), filePopup );
	menuBar()->insertSeparator();
	menuBar()->insertItem ( i18n( "&Help" ), helpMenu() );

		
	// List Box for Groups
  groupBox = new QGroupBox( this, "groupBox" );
  groupBox->setGeometry( QRect( 5, 30, 220, 185 ) );
  groupBox->setFrameShadow( QGroupBox::Plain );

  cmdBackGroup = new QPushButton( groupBox, "cmdBackGroup" );
  cmdBackGroup->setGeometry( QRect( 87, 130, 22, 22 ) );
  cmdBackGroup->setText( "<" );
  cmdBackGroup->setAutoMask( true );
	if(isShowTipChecked){
  	QToolTip::add(  cmdBackGroup, i18n( "Back" ) );
  }

  cmdForwardGroup = new QPushButton( groupBox, "cmdForwardGroup" );
  cmdForwardGroup->setGeometry( QRect( 108, 130, 22, 22 ) );
  cmdForwardGroup->setText( ">" );
  cmdForwardGroup->setAutoMask( true );
	if(isShowTipChecked){
	  QToolTip::add(  cmdForwardGroup, i18n( "Forward" ) );
  }

  lblGroup = new QLabel( groupBox, "lblGroup" );
  lblGroup->setGeometry( QRect( 5, 5, 195, 21 ) );
  lblGroup->setText( i18n( groupConfMain ) );
  lblGroup->setFrameShadow( QLabel::Plain );

  listGroup = new QListBox( groupBox, "listGroup" );
  listGroup->setGeometry( QRect( 5, 26, 210, 100 ) );
  listGroup->setAcceptDrops( true );
  QWhatsThis::add(  listGroup, i18n(
			"This the listbox where you'll find your groups to manage your passwords. Be "
			"careful when delete some groups; all existing password items will be deleted "
			"as well. If you want to keep them, so move them to another group first." ) );

  cmdNewGroup = new QPushButton( groupBox, "cmdNewGroup" );
  cmdNewGroup->setGeometry( QRect( 5, 156, 55, 22 ) );
  cmdNewGroup->setText( i18n( "Ne&w" ) );
  cmdNewGroup->setAutoMask( true );
	if(isShowTipChecked){
		QToolTip::add( cmdNewGroup, i18n( "Create new group" ) );
  }

  cmdEditGroup = new QPushButton( groupBox, "cmdEditGroup" );
  cmdEditGroup->setGeometry( QRect( 60, 156, 85, 22 ) );
  cmdEditGroup->setText( i18n( "Ed&it" ) );
  cmdEditGroup->setAutoMask( true );
	if(isShowTipChecked){
		QToolTip::add( cmdEditGroup, i18n( "Edit marked group" ) );
  }

  cmdDeleteGroup = new QPushButton( groupBox, "cmdDeleteGroup" );
  cmdDeleteGroup->setGeometry( QRect( 145, 156, 70, 22 ) );
  cmdDeleteGroup->setText( i18n( "De&lete" ) );
  cmdDeleteGroup->setAutoMask( true );
	if(isShowTipChecked){
		QToolTip::add( cmdDeleteGroup, i18n( "Delete marked group with all existing entrys" ) );
  }

	// Password List Box
  passwordBox = new QGroupBox( this, "passwordBox" );
  passwordBox->setGeometry( QRect( 5, 219, 220, 205 ) );
  passwordBox->setFrameShadow( QGroupBox::Plain );
  passwordBox->setFrameShape( QGroupBox::Box );

  cmdBackPassword = new QPushButton( passwordBox, "cmdBackPassword" );
  cmdBackPassword->setGeometry( QRect( 87, 150, 22, 22 ) );
  cmdBackPassword->setText( "<" );
  cmdBackPassword->setAutoMask( true );
	if(isShowTipChecked){
  	QToolTip::add(  cmdBackPassword, i18n( "Back" ) );
  }

  cmdForwardPassword = new QPushButton( passwordBox, "cmdForwardPassword" );
  cmdForwardPassword->setGeometry( QRect( 108, 150, 22, 22 ) );
  cmdForwardPassword->setText( ">" );
  cmdForwardPassword->setAutoMask( true );
	if(isShowTipChecked){
  	QToolTip::add(  cmdForwardPassword, i18n( "Forward" ) );
  }

  cmdNewPassword = new QPushButton( passwordBox, "cmdNewPassword" );
  cmdNewPassword->setGeometry( QRect( 5, 176, 55, 22 ) );
  cmdNewPassword->setText( i18n( "&New" ) );
  cmdNewPassword->setAutoMask( true );
	if(isShowTipChecked){
  	QToolTip::add(  cmdNewPassword, i18n( "Create new password entry" ) );
  }

  cmdEditPassword = new QPushButton( passwordBox, "cmdEditPassword" );
  cmdEditPassword->setGeometry( QRect( 60, 176, 85, 22 ) );
  cmdEditPassword->setText( i18n( "&Edit" ) );
  cmdEditPassword->setAutoMask( true );
	if(isShowTipChecked){
		QToolTip::add( cmdEditPassword, i18n( "Edit marked password entry" ) );
  }

  cmdDeletePassword = new QPushButton( passwordBox, "cmdDeletePassword" );
  cmdDeletePassword->setGeometry( QRect( 145, 176, 70, 22 ) );
  cmdDeletePassword->setText( i18n( "&Delete" ) );
  cmdDeletePassword->setAutoMask( true );
	if(isShowTipChecked){
		QToolTip::add( cmdDeletePassword, i18n( "Delete marked password entry" ) );
  }

  lblPasswordList = new QLabel( passwordBox, "lblPasswordList" );
  lblPasswordList->setGeometry( QRect( 5, 6, 200, 20 ) );
  lblPasswordList->setText( i18n( "Passwordlist" ) );

  listPasswordList = new QListBox( passwordBox, "listPasswordList" );
  listPasswordList->insertItem( i18n( "Empty" ) );
  listPasswordList->setGeometry( QRect( 5, 26, 210, 120 ) );
	QWhatsThis::add(  listPasswordList, i18n(
			"This listbox shows your passwords from the selected groups above. In options "
			"dialog you can choose if a doubleclick opens the edit mask or launch the given url." ) );

	// databox
	// Password data Box nowrite
  dataBox = new QGroupBox( this, "dataBox" );
  dataBox->setGeometry( QRect( 229, 30, 220, 355 ) );
  dataBox->setLineWidth( 1 );
  dataBox->setFrameShadow( QGroupBox::Plain );

		// UserName
  lblUserName = new QLabel( dataBox, "lblUserName" );
  lblUserName->setGeometry( QRect( 5, 83, 175, 16 ) );
  lblUserName->setText( i18n( "UserName:" ) );

  txtUserName = new QLineEdit( dataBox, "txtUserName" );
  txtUserName->setGeometry( QRect( 5, 100, 183, 22 ) );
  txtUserName->setAcceptDrops( false );
  txtUserName->setEnabled( true );
  txtUserName->setReadOnly( true );
	QWhatsThis::add(  txtUserName, i18n(
			"This field contains the usernname to the password. You can copy the username by "
			"mouse or click on the button on the right side, to copy the username into the clipboard." ) );
  //txtUserName->setFocusPolicy( QLineEdit::NoFocus );

  cmdCopyUser = new QPushButton( dataBox, "cmdCopyUser" );
  cmdCopyUser->setGeometry( QRect( 192, 100, 22, 22 ) );
  cmdCopyUser->setPixmap( image1 );
  cmdCopyUser->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdCopyUser, i18n( "Copy username to clipboard" ) );
  }

	//Password
  lblPassword = new QLabel( dataBox, "lblPassword" );
  lblPassword->setGeometry( QRect( 5, 124, 179, 16 ) );
  lblPassword->setText( i18n( "Password:" ) );

  txtPassword = new QLineEdit( dataBox, "txtPassword" );
  txtPassword->setGeometry( QRect( 5, 141, 183, 22 ) );
  txtPassword->setAcceptDrops( false );
	txtPassword->setReadOnly( true );
	QWhatsThis::add(  txtPassword, i18n(
			"This field contains your password. You can copy the password by mouse or click on "
			"the button on the right side, to copy the password into the clipboard." ) );

  cmdCopyPassword = new QPushButton( dataBox, "cmdCopyPassword" );
  cmdCopyPassword->setGeometry( QRect( 192, 141, 22, 22 ) );
  cmdCopyPassword->setPixmap( image1 );
  cmdCopyPassword->setFocusPolicy( QPushButton::TabFocus );
  if(isShowTipChecked){
  	QToolTip::add(  cmdCopyPassword, i18n( "Copy password to clipboard" ) );
  }

  //webaddress
  lblUrl = new QLabel( dataBox, "lblUrl" );
  lblUrl->setGeometry( QRect( 5, 165, 174, 16 ) );
  lblUrl->setText( i18n( "Webaddress" ) );

  txtUrl = new QLineEdit( dataBox, "txtUrl" );
  txtUrl->setGeometry( QRect( 5, 182, 183, 22 ) );
  txtUrl->setAcceptDrops( false );
  txtUrl->setReadOnly( true );
	QWhatsThis::add(  txtUrl, i18n(
			"This field contains the web url to your password. You can copy the url by mouse "
			"or click on the button on the right side, to copy the url into the clipboard." ) );

  cmdOpenBrowser = new QPushButton( dataBox, "cmdOpenBrowser" );
  cmdOpenBrowser->setGeometry( QRect( 192, 195, 22, 22 ) );
  cmdOpenBrowser->setPixmap( image2 );
  cmdOpenBrowser->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdOpenBrowser, i18n( "Open URL in browser" ) );
  }

  cmdCopyUrl = new QPushButton( dataBox, "cmdCopyUrl" );
  cmdCopyUrl->setGeometry( QRect( 192, 171, 22, 22 ) );
  cmdCopyUrl->setPixmap( image1 );
  cmdCopyUrl->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdCopyUrl, i18n( "Copy url to clipboard" ) );
  }
  //groupdescription
  lblGroupDescript = new QLabel( dataBox, "lblGroupDescript" );
  lblGroupDescript->setGeometry( QRect( 5, 5, 169, 18 ) );
  lblGroupDescript->setText( i18n( "Group description" ) );

  txtGroup = new QMultiLineEdit( dataBox, "txtGroup" );
  txtGroup->setGeometry( QRect( 5, 26, 183, 56 ) );
  txtGroup->setAcceptDrops( false );
  txtGroup->setWordWrap( QMultiLineEdit::WidgetWidth );
  txtGroup->setWrapColumnOrWidth( -1 );
	txtGroup->setReadOnly( true );
	QWhatsThis::add(  txtGroup, i18n(
			"This field contains a description of your current group. You can edit this field by "
			"double clicking a item in the groupbox or press the group edit button. Clicking on "
			"the button at the right side will copy the text into the clipboard." ) );


  cmdCopyGroup = new QPushButton( dataBox, "cmdCopyGroup" );
  cmdCopyGroup->setGeometry( QRect( 192, 25, 22, 22 ) );
  cmdCopyGroup->setPixmap( image1 );
  cmdCopyGroup->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdCopyGroup, i18n( "Copy Group description to clipboard" ) );
  }

	// show date created
  lblDateCreated = new QLabel( dataBox, "lblDateCreated" );
  lblDateCreated->setGeometry( QRect( 5, 205, 178, 16 ) );
  lblDate = new QLabel( dataBox, "lblDate" );
  lblDate->setGeometry( QRect( 5, 219, 199, 20 ) );
  QFont lblDate_font(  lblDate->font() );
  lblDate_font.setBold( true );
  lblDate->setFont( lblDate_font );

  //memo
  lblMemo = new QLabel( dataBox, "lblMemo" );
  lblMemo->setGeometry( QRect( 5, 238, 69, 14 ) );
  lblMemo->setText( i18n( "Memo:" ) );

  txtMemo = new QMultiLineEdit( dataBox, "txtMemo" );
  txtMemo->setGeometry( QRect( 5, 254, 183, 92 ) );
  txtMemo->setAcceptDrops( false );
  txtMemo->setWordWrap( QMultiLineEdit::WidgetWidth );
  txtMemo->setReadOnly( true );
	QWhatsThis::add(  txtMemo, i18n(
			"This field contains a memo to your password. You can copy the text by mouse or "
			"click on the button on the right side, to copy the the memo into the clipboard." ) );


  cmdCopyMemo = new QPushButton( dataBox, "cmdCopyMemo" );
  cmdCopyMemo->setGeometry( QRect( 192, 253, 22, 22 ) );
  cmdCopyMemo->setPixmap( image1 );
  cmdCopyMemo->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdCopyMemo, i18n( "Copy memo to clipboard" ) );
  }

  cmdOptions = new QPushButton( dataBox, "cmdOptions" );
  cmdOptions->setGeometry( QRect( 192, 277, 22, 22 ) );
  cmdOptions->setPixmap( image5 );       // image5
  cmdOptions->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdOptions, i18n("Options") );
  }

  cmdBackup = new QPushButton( dataBox, "cmdBackup" );
  cmdBackup->setGeometry( QRect( 192, 301, 22, 22 ) );
  cmdBackup->setPixmap( image3 );
  cmdBackup->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdBackup, i18n( "Create backup" ) );
  }

  cmdPrint = new QPushButton( dataBox, "cmdPrint" );
  cmdPrint->setGeometry( QRect( 192, 325, 22, 22 ) );
  cmdPrint->setPixmap( image4 );
  cmdPrint->setFocusPolicy( QPushButton::TabFocus );
	if(isShowTipChecked){
  	QToolTip::add(  cmdPrint, i18n( "Print Options" ) );
  }

  // Button Box
  buttonBox = new QGroupBox( this, "buttonBox" );
  buttonBox->setGeometry( QRect( 229, 389, 220, 35 ) );
  buttonBox->setFrameShadow( QGroupBox::Plain );

  cmdQuit = new QPushButton( buttonBox, "cmdQuit" );
  cmdQuit->setGeometry( QRect( 5, 6, 209, 22 ) );
  cmdQuit->setText( i18n( "&Quit" ) );
  cmdQuit->setAutoMask( true );
	if(isShowTipChecked){
  	QToolTip::add(  cmdQuit, i18n( "Quit the program -> good bye :)" ) );
  }

	// Connects
	// quit the app
	connect( cmdQuit, SIGNAL( clicked() ), this, SLOT( appQuit() ) );
	// open the dialogs
	connect( cmdOptions, SIGNAL( clicked() ), this, SLOT( openOptions() ) );
  connect( cmdNewGroup, SIGNAL( clicked() ), this, SLOT( openNewGroupWin() ) );
  connect( cmdNewPassword, SIGNAL( clicked() ), this, SLOT( pwdNewMask() ) );
	connect( cmdEditGroup, SIGNAL( clicked() ), this, SLOT( openEditGroupWin()	 ) );
	connect( cmdEditPassword, SIGNAL( clicked() ), this, SLOT( pwdEditMask()	 ) );
	connect( cmdPrint, SIGNAL( clicked() ), this, SLOT( openPrinter()	 ) );
	connect( cmdBackup, SIGNAL( clicked() ), this, SLOT( openBackup() ) );
  // handle the group listbox es
	connect( listGroup, SIGNAL( selectionChanged() ), this, SLOT( groupSelected() ) );
	connect( listGroup, SIGNAL( selectionChanged() ), this, SLOT( clearPasswords() ) );
	connect( listGroup, SIGNAL( selectionChanged() ), this, SLOT( selectGroupDesrc() ) );
	connect( listGroup, SIGNAL( selected(QListBoxItem *) ), this, SLOT( groupListDoubleClick() ) );
	connect( listPasswordList, SIGNAL( selectionChanged() ), this, SLOT( passwordSelected() ) );	
	connect( listPasswordList, SIGNAL( selected(QListBoxItem *) ), this, SLOT( passwordListDoubleClick() ) );
	// handles the forward and back buttons of both listboxes
	connect( cmdForwardGroup, SIGNAL( clicked() ), this, SLOT( forwardGroupList() ) );
	connect( cmdBackGroup, SIGNAL( clicked() ), this, SLOT( backGroupList() ) );
	connect( cmdForwardPassword, SIGNAL( clicked() ), this, SLOT( forwardPasswordList() ) );
	connect( cmdBackPassword, SIGNAL( clicked() ), this, SLOT( backPasswordList() ) );
	// delete a item
	connect( cmdDeleteGroup, SIGNAL( clicked() ), this, SLOT( deleteGroupItem() ) );
	connect( cmdDeletePassword, SIGNAL( clicked() ), this, SLOT( deletePasswordItem() ) );

	connect( cmdCopyPassword, SIGNAL( clicked() ), this, SLOT( copyPassword() ) );
	connect( cmdCopyUser, SIGNAL( clicked() ), this, SLOT( copyUserName() ) );
	connect( cmdCopyUrl, SIGNAL( clicked() ), this, SLOT( copyUrl() ) );
	connect( cmdCopyGroup, SIGNAL( clicked() ), this, SLOT( copyGroupDescr() ) );
	connect( cmdCopyMemo, SIGNAL( clicked() ), this, SLOT( copyMemo() ) );
	connect( cmdOpenBrowser, SIGNAL( clicked() ), this, SLOT( startWebApp() ) );

	// tab orders
  setTabOrder( cmdBackGroup, cmdForwardGroup );
  setTabOrder( cmdForwardGroup, cmdNewGroup );
  setTabOrder( cmdNewGroup, cmdEditGroup );
  setTabOrder( cmdEditGroup, cmdDeleteGroup );
  setTabOrder( cmdDeleteGroup, listPasswordList );
  setTabOrder( listPasswordList, cmdBackPassword );
  setTabOrder( cmdBackPassword, cmdForwardPassword );
  setTabOrder( cmdForwardPassword, cmdNewPassword );
  setTabOrder( cmdNewPassword, cmdEditPassword );
  setTabOrder( cmdEditPassword, cmdDeletePassword );
  setTabOrder( cmdDeletePassword, txtPassword );
  setTabOrder( txtPassword, cmdCopyUser );
  setTabOrder( cmdCopyUser, txtPassword );
  setTabOrder( txtPassword, cmdCopyPassword );
  setTabOrder( cmdCopyPassword, txtUrl );
  setTabOrder( txtUrl, cmdCopyUrl );
  setTabOrder( cmdCopyUrl, cmdOpenBrowser );
  setTabOrder( cmdOpenBrowser, cmdCopyGroup );
  setTabOrder( cmdCopyGroup, txtMemo );
  setTabOrder( txtMemo, cmdCopyMemo );
  setTabOrder( cmdCopyMemo, cmdBackup );
  setTabOrder( cmdBackup, cmdPrint );
  setTabOrder( cmdPrint, cmdQuit );
  setTabOrder( cmdQuit, txtPassword );
	setGroups();

}


// open dialog for backup
void Kpass::openBackup(){
		outPut( false );
}


// opens dialog to print the password stuff
void Kpass::openPrinter(){
		outPut( true );
}

// define the function for the Kpout class
// and do specified jobs
void Kpass::outPut(bool isPrint){
  Kpout *kpout = new Kpout();
	getMainWinPos();	
	QPoint q( 78, 96 );
	mainWinPos += q;
	kpout->move ( mainWinPos ); //
	if(isPrint){ // widget for prints
    kpout->setCaption( i18n( "Print options" ) );
	  kpout->rbAllPassword->setText( i18n( "Print all passwords with selected data" ) );		
    kpout->rbSinglePassword->setText( i18n( "Print current  Password with selected data" ) );
    kpout->rbRawFile->setText( i18n( "Print raw unformattet passwordfile" ) );
  	kpout->rbGroupPassword->setText( i18n( "Print current group with selected data" ) );
    QWhatsThis::add(  kpout->mainBox, i18n(
		"You can get preformatted outputs by choosing the needed items. If you "
		"want to get the file in digital format use the backup function." ) );

	}else{  // widget for backup
    kpout->setCaption( i18n( "Backup options" ) );
	  kpout->rbAllPassword->setText( i18n( "Save all passwords with selected data" ) );
    kpout->rbSinglePassword->setText( i18n( "Save current  Password with selected data" ) );
    kpout->rbRawFile->setText( i18n( "Save original raw passwordfile" ) );
    kpout->rbGroupPassword->setText( i18n( "Save current group with selected data" ) );
		QWhatsThis::add(  kpout->mainBox, i18n(
		"You can get preformatted digital outputs by choosing the needed items. "
		"If you want to send this formatted to printer use the print function." ) );

	}
	// get configuration from dialog
  if(kpout->exec() == QDialog::Accepted){
		bool a = kpout->getIsGroupChecked(); 		
		bool b = kpout->getIsListnameChecked();
		bool c = kpout->getIsPasswordChecked();
		bool d = kpout->getIsUsernameChecked();
		bool e = kpout->getIsUrlChecked();
		bool f = kpout->getIsDateChecked();
		bool g = kpout->getIsMemoChecked();
		bool isSingleChecked = kpout->getIsSingleChecked();
		bool isGrpChecked 	 = kpout->getIsGrpChecked();
		bool isAllChecked 	 = kpout->getIsAllChecked();
		bool isRawChecked 	 = kpout->getIsRawChecked();	
    QString outDat; //output data
    bool outOk = true;
		// putting the data together for single
		if(isSingleChecked){
			QString group = listPasswordList->currentText();
		  outDat = outDat+outPutGenerator( group, true, a, b, c, d, e, f, g );
			if(outDat == ""){ outOk = false; }else{ outOk = true; }
		// putting the data together for groups
		}else if(isGrpChecked){
			QString group = listGroup->currentText();
			outDat = outDat+"<br><br>"+i18n( "group: " )+"\t"+group;
		  outDat = outDat+outPutGenerator( group, false, a, b, c, d, e, f, g );
		// putting the data together for all data
		}else if(isAllChecked){
			KConfig kconfig( filePath , false, false );
 			QMap < QString, QString > myGroups =  kconfig.entryMap("Groups");
			QMap < QString, QString >::Iterator itg;	
      for (itg = myGroups.begin(); itg != myGroups.end(); ++itg){
				QString group = (itg.key() ).latin1();
				if( a ){
					outDat = outDat+"<br><br>"+i18n( "group: " )+"\t"+group;
				}else{
					outDat = outDat+"<br><br>";					
				}
				outDat = outDat+outPutGenerator( group, false, a, b, c, d, e, f, g );
			}	
		// putting the data together for raw file
		}else if( isRawChecked ){ // rawFile
     //f.setName( "readme.txt" );
			QDir::setCurrent( filePath );
      QFile pwdFile ( filePath );    //   dataFileName
			QFileInfo dExists ( filePath );
			QFileInfo fileExists ( filePath );
			if( ! fileExists.exists() ){
  			QMessageBox::warning( this, i18n( "File error" ), i18n(
							"No File for your Passwords found!\n\nThere must be really something "
							"wrong!\nKpass quits now!") );
			}
			pwdFile.open (IO_ReadOnly);
			QTextStream stream ( &pwdFile );
			outDat = stream.read();
			//KMessageBox::information(this, outDat );
			pwdFile.close();
					
		}else{
			// this really should never happen
			QMessageBox::warning(this, i18n( "Dialog error!" ),i18n( "\n Please restart programm." ) );
		}			
		if( outOk ){ // ask if not focussed single
	    if(isPrint){  // what job? print or save
				QPrinter printer;
    		printer.setFullPage(TRUE);
    		if (printer.setup()) {
        	QPainter p(&printer);
        	QPaintDeviceMetrics metrics(p.device());
        	int dpix = metrics.logicalDpiX();
        	int dpiy = metrics.logicalDpiY();
        	const int margin = 42; // pt
        	QRect body(margin*dpix/42, margin*dpiy/42,
                   metrics.width()-margin*dpix/42*2,
                   metrics.height()-margin*dpiy/42*2 );
        	QFont font("helvetica", 12);
        	QSimpleRichText header(QString( "<b>" )+i18n(
					"Kpass - KDE Internet password manager - www.sitedesign.ch" )
					+QString ( "</b><hr>" ), font, 0, 0, 0, -1);
        	header.setWidth(&p, body.width());
        	QSimpleRichText richText(outDat, font, 0, 0, 0, body.height()-header.height());
        	richText.setWidth(&p, body.width());
        	QRect view(body);
        	int page = 1;
        	do {
        	  header.draw(&p, body.left(), body.top(), view, colorGroup());
            richText.draw(&p, body.left(), body.top()+header.height(), view, colorGroup());
            view.moveBy(0, body.height());
            p.translate(0 , -body.height());
            p.setFont(font);
            p.drawText(view.right() - p.fontMetrics().width( QString::number(page)),
                    view.bottom()+p.fontMetrics().ascent()+5, QString::number(page));
            if (view.top() >= richText.height())
                break;
            printer.newPage();
            page++;
        	} while (TRUE);
    		}	
			}else{ // in this case i save	and first make a html file			
				QString htmlHead = QString( "<html><head><title>" )
													+i18n( "Kpass - Internet password manager" )
													+QString( " - www.sitedesign.ch</title></head></body><b>" )
													+i18n( "Kpass - Internet password manager" )
													+QString( " - <a href=\"http://www.sitedesign.ch\">www.sitedesign.ch</b><hr>" );
				QString htmlFooter = QString( "</body></html>" );
				// ask for a save dir
  			QFileDialog *saveSlutDlg = new QFileDialog(this, "saveSlutDlg");
  			saveSlutDlg->setMode(QFileDialog::ExistingFile);
				// set extentions and type
				QString fileName;
				if( isRawChecked ){
        	fileName = saveSlutDlg->getSaveFileName( "kpass.dat" , "*.dat", this ,i18n( "Save" ),
																																 i18n( "Save original file" ) );
				}else{
  				fileName = saveSlutDlg->getSaveFileName( "kpasswords.html" , "*.html", this,
																							i18n( "Save" ), i18n( "Save as html file" ) );
				}
				bool fileIs = false;
				if ( !fileName.isNull() ) {
					QFileInfo fileExists ( fileName );
					if( fileExists.exists() ){ // if the file is there dialog
  					int really = KMessageBox::warningYesNo( this, i18n( "This File exists!" )
												+QString( "\n\n" )+i18n( "Do you really want to overwrite?") );
						if(really == KMessageBox::Yes){
           	   fileIs = true;
						}
						if(really == KMessageBox::No){
           	   fileIs = false;
						}
					}
					if( ! isRawChecked ){
						if(fileIs){				
							QFile pwdFile ( fileName );
							pwdFile.open ( IO_WriteOnly );
							QTextStream stream ( &pwdFile );
							stream << htmlHead;
							stream << outDat;
							stream << htmlFooter;
							pwdFile.close();
						}else{
							KMessageBox::information( this, i18n( "Nothing has been saved!" ) );			
						}
					}else{ // is raw checked
						// get it
						QFile origFile ( filePath );
						origFile.open (IO_ReadOnly);
						QTextStream streamOrig ( &origFile );
						outDat = streamOrig.read();
						origFile.close();
            // give it
						QFile pwdFile ( fileName );
						pwdFile.open ( IO_WriteOnly );
						QTextStream stream ( &pwdFile );
						stream << outDat;
						pwdFile.close();						
					}	
				}	
			}		
		}
		delete kpout;
	}
}


// a generator to get the data together for print and save
QString Kpass::outPutGenerator( QString group, bool single, bool a, bool b, bool c, bool d, bool e, bool f, bool g ){
  QString outDat = "";
	if(single){		
		if( listPasswordList->currentText() ){
			// check witch checkboxes are checked
			QString br = "<br>";
			if( a ){ outDat = br+i18n( "group: " )+listGroup->currentText(); }	
			if( b ){ outDat = outDat+br+i18n( "listname: " )+listPasswordList->currentText(); }
			if( c ){ outDat = outDat+br+i18n( "password: " )+txtPassword->text(); }
			if( d ){ outDat = outDat+br+i18n( "username: " )+txtUserName->text(); }
			if( e ){ outDat = outDat+br+i18n( "url: " )+txtUrl->text(); } 		
			if( f ){ outDat = outDat+br+i18n( "date: " )+lblDate->text(); } 		
			if( g ){ outDat = outDat+br+i18n( "memo: " )+txtMemo->text(); }
      // now i get outDat filled with single password data
	  }else{
			// if no listitem is selected
			KMessageBox::information(this, i18n( "No password selected!"
		 				"\n\nTo print a single password\n select a password item first." ) );	
    }
	}else{
		// here i get the group and single data
		KConfig config( filePath , false, false );
 		QMap < QString, QString > myPwdList =  config.entryMap( group );
		QMap < QString, QString >::Iterator itp;
		for (itp = myPwdList.begin(); itp != myPwdList.end(); ++itp){
			QString list = (itp.key() ).latin1();
  	  QString data = QString ( (*itp).latin1() );
			QStringList myEntrys = QStringList::split("|",data);
			if( b ){
				outDat = outDat+"<br><br>"+i18n( "listname: " )+"\t"+list;
			}else{
				outDat = outDat+"<br><br>";
			}
			int i = 0;
			for ( QStringList::Iterator itq = myEntrys.begin(); itq != myEntrys.end(); ++itq ) {
				QString values = QString ( *itq );
				switch (i){
					case 0:
	          if( d ){ outDat = outDat+"<br>"+i18n( "username: " )+"\t"+values; }
						break;
					case 1:
						if( c ){ outDat = outDat+"<br>"+i18n( "password: " )+"\t"+values; }
						break;
					case 2:
						urlProtocol = values;
						break;
					case 3:
						if( e ){ outDat = outDat+"<br>"+i18n( "url: " )+"\t"+urlProtocol+values; }
						break;
					case 4:
	          if( f ){ outDat = outDat+"<br>"+i18n( "date: " )+"\t"+values; }
						break;
					case 5:
	          if( g ){ outDat = outDat+"<br>"+i18n( "memo: " )+"\t"+values; }
						break;
					
					default:
					// should not apera in any case	
					QMessageBox::warning( 0, i18n( "File error" ), i18n( "Please restart program." ) );			
	  		}
	      i++;
			}
		}
	}
	return QString( outDat );
}



//check bevor Main app close
void Kpass::appQuit(){
	if( isInfoMsgChecked ){
		int really = KMessageBox::questionYesNo(this, i18n("Do you really want to quit?") );
		if (really == KMessageBox::Yes){
			kapp->quit();
		}
	}else{
		kapp->quit();
	}	
}


// redirector for slot to select functions of password dialog
void Kpass::pwdNewMask(){
	if(listGroup->currentItem() == -1){
    KMessageBox::information(this, i18n("No Groups defined!\nYou have to create a group first.") );
	}else{	
		openPwdMask( false );
	}
}


// redirector slot to select functions of password dialog
void Kpass::pwdEditMask(){
	if(listGroup->currentItem() == -1){
    KMessageBox::information(this, i18n("No Groups defined!\nYou have to create a group first.") );
	}else{
		if(listPasswordList->currentItem() == -1){
   		KMessageBox::information(this, i18n("Nothing to do!\nNo Password item selected") );	
		}else{
			openPwdMask( true );
		}
	}
}


// open mask either for new passwords or edit
void Kpass::openPwdMask( bool edit ){
	isEdit = edit;
  Kppwd *kppwd = new Kppwd();
	getMainWinPos();	
	QPoint q( 1, 61 );
	mainWinPos += q;
	kppwd->move ( mainWinPos );
	// save the current Items and Text
	int listPwdCurrentItem = listPasswordList->currentItem();
	QString oldPwdDescription = listPasswordList->currentText();
	QString oldGroup = listGroup->currentText();
	QString newGroup;
	// prepare new Items and Text
	QString u0="http://", u1="https//:", u2="ftp://";	
	QString listPwdNewItem;
	QString listGrpNewItem;
	QString listPwdNewText;
	QString listGrpNewText;
	KConfig kconfig( filePath , false, false );
 	QMap < QString, QString > myGroups =  kconfig.entryMap(groupConfMain);
	QMap < QString, QString >::Iterator it;
	// is dialog for new or edit entry?
	if(edit == false){
		kppwd->setCaption( i18n( "New password" ) );			
		// set the combo items to choose existent groups
		for (it = myGroups.begin(); it != myGroups.end(); ++it){
			QString key = (it.key()).latin1();
			kppwd->setComboGroup(key);
			if(key == oldGroup){
				kppwd->setComboGroupItem();
			}
		}
    kppwd->setComboProtocol( u0 );
    kppwd->setComboProtocol( u1 );
    kppwd->setComboProtocol( u2 );
	}else{
		kppwd->setCaption( i18n( "Edit password" ) );
		// set the combo items and set group
		for (it = myGroups.begin(); it != myGroups.end(); ++it){
			QString key = (it.key()).latin1();
			kppwd->setComboGroup(key);
			if(key == listGroup->currentText()){
				kppwd->setComboGroupItem();
			}
    }	
		if(urlProtocol == u0){
			kppwd->setComboProtocol( u0 );
			kppwd->setComboProtocolItem();
		}else{
			kppwd->setComboProtocol( u0 );
		}
		if(urlProtocol == u1){
			kppwd->setComboProtocol( u1 );
			kppwd->setComboProtocolItem();
		}else{
			kppwd->setComboProtocol( u1 );
		}
		if(urlProtocol == u2){
			kppwd->setComboProtocol( u2 );
			kppwd->setComboProtocolItem();
		}else{
			kppwd->setComboProtocol( u2 );
		}
		kppwd->setDescription( listPasswordList->currentText() );
		kppwd->setTxtPassword( txtPassword->text() );
		kppwd->setTxtUserName( txtUserName->text() );
		kppwd->setTxtUrl( urlString );
		kppwd->setTxtMemo( txtMemo->text() );
	}
	// get the data from the dialog
	bool isAccepted = false;
	if(kppwd->exec() == QDialog::Accepted){
		isAccepted = true;
		QString newPwdDescription = kppwd->getPwdDescription();
		QString newGroup = kppwd->getGroup();
   	QString groupDescription;
		for (it = myGroups.begin(); it != myGroups.end(); ++it){
			QString key = (it.key() ).latin1();
			QString values = QString ( (*it).latin1() );
			if( (kppwd->getGroup() ) == key){
				groupDescription = values;
			}
		}	
 		KSimpleConfig conf ( filePath );
   	
		listGrpNewText = kppwd->getGroup();
		QString a = kppwd->getUserName();
		if(a == ""){ a = "-";}  // aarrrghhhh must have a split thing
		QString b = kppwd->getPassword();
		if(b == ""){ b = "-";}
		QString c = kppwd->getProtocol();
		QString d = kppwd->getUrl();
		if(d == ""){ d = "-";}
		QString e;		
		if(edit == false){
			QDate dt = QDate::currentDate();
      // set the value for internationalisation
			QString str = KGlobal::locale()->formatDate( dt, false );
      e = str;
		}else{
			e = lblDate->text();
		}
		QString f = kppwd->getMemo();
		if(f == ""){ f = "-";}
		// username / password / protocol / url / date / memo
		QString data = a+"|"+b+"|"+c+"|"+d+"|"+e+"|"+f;
   	// look if group has changed	
		if(newGroup == oldGroup){  // no group changes
			conf.setGroup ( oldGroup );
			if(edit == true){
				conf.deleteEntry ( oldPwdDescription, false );
			}
			conf.writeEntry ( kppwd->getPwdDescription(), data );
		}else{
			// group has changed
			if(edit == true){																	
				conf.setGroup ( oldGroup );
				conf.deleteEntry ( oldPwdDescription, false );
			}
			conf.setGroup ( newGroup );
			conf.writeEntry ( kppwd->getPwdDescription(), data );
			if(edit == true){
				if(isInfoMsgChecked){
  				KMessageBox::information(this, i18n( QString( "Password move:\n\n"
						"'%1'\n\nhas been moved to group:\n\n'%2'" )
						.arg(kppwd->getPwdDescription())
						.arg(kppwd->getGroup())) );
				}
			}else{
				if(isInfoMsgChecked){
  				KMessageBox::information(this, i18n( QString( "Create password: \n\n"
						"'%1' \nhas been created in:\n'%2'")
						.arg( kppwd->getPwdDescription() )
						.arg( kppwd->getGroup()) ) );
				}
   	  }
		}
	}		
	// clear and rewrite to update list if changed, groupitem is still selected
	if(isAccepted){
		listPasswordList->clear();
		groupSelected();
		if(edit == true){
			listPasswordList->setCurrentItem( listPwdCurrentItem );
		}else{
  		QListBoxItem* listBoxItem = listPasswordList->findItem( kppwd->getPwdDescription() );
  		if( listBoxItem ){
  	  	listPasswordList->setFocus();
  	  	listPasswordList->setCurrentItem( listBoxItem );
  	  }
		}
  }else{
		// no changes done set last list item
   	listPasswordList->setCurrentItem( listPwdCurrentItem );
	}
	delete kppwd;
}


// open mask for new groups and select functions
void Kpass::openNewGroupWin(){
	openGrpMask( false );	
}


// open mask to edit selected group
void Kpass::openEditGroupWin(){
	openGrpMask( true );
}

// open the group mask for edit or new
void Kpass::openGrpMask( bool edit ){
  Kpgrp *kpgrp = new Kpgrp();
	getMainWinPos();
	QPoint q( 102, 111 );
	mainWinPos += q;	
	kpgrp->move ( mainWinPos );
	int lastListPos = listGroup->currentItem();
	// is dialog for new or edit entry?
	if(edit == false){
		kpgrp->setCaption( i18n( "New group" ) );			
		isEdit = false;
	}else{
    kpgrp->setCaption( i18n( "Edit group" ) );	
		kpgrp->setGroup( listGroup->currentText() );
		isEdit = true;
		KConfig kconfig( filePath , false, false );
 		QMap < QString, QString > myGroups =  kconfig.entryMap(groupConfMain);
		QMap < QString, QString >::Iterator it;
		for (it = myGroups.begin(); it != myGroups.end(); ++it){
			QString key = (it.key() ).latin1();
			QString values = QString ( (*it).latin1() );
			if( (listGroup->currentText() ) == key){
				kpgrp->setDescription( values );
			}
		}
	}
	// get the data from the dialog
  bool isAccepted = false;
  QString newGrp;
	QString oldGrp;
  if(kpgrp->exec() == QDialog::Accepted){
		isAccepted = true;
		newGrp = kpgrp->getGroupName();
		oldGrp = listGroup->currentText();
		if(edit == true){
		// if just description changes
			if( oldGrp == newGrp ){
				KSimpleConfig conf ( filePath );
	 	 		conf.setGroup( groupConfMain );
				conf.writeEntry ( oldGrp, kpgrp->getDescription() );
			}else{
				KSimpleConfig conf ( filePath );
				// first write new group
	 	 		conf.setGroup( groupConfMain );
				conf.writeEntry ( newGrp, kpgrp->getDescription() );
				// set new group for ksimpleconfig
				conf.setGroup( newGrp );
				// get a map of the old Group
				KConfig kconfig( filePath , false, false );
 				QMap < QString, QString > myGroups =  kconfig.entryMap( oldGrp );
				QMap < QString, QString >::Iterator it;
				// insert old group items to new group
				for( it = myGroups.begin(); it != myGroups.end(); ++it ){
					QString key = ( it.key() ).latin1();
					QString values = QString ( (*it).latin1() );
					conf.writeEntry( key, values );
				}		
				// delete old group and main entry
				KSimpleConfig confs ( filePath );			
	 	    conf.deleteGroup ( oldGrp );
				conf.setGroup ( groupConfMain );
				conf.deleteEntry( oldGrp, false );   	
			}
		}else{
				KSimpleConfig conf ( filePath );
	 	 		conf.setGroup( groupConfMain );
				conf.writeEntry ( newGrp, kpgrp->getDescription() );
		}		
	}
	// something has changed in the dialog
	if(isAccepted){
		listGroup->clear();
		setGroups();
  	QListBoxItem* listBoxItem = listGroup->findItem( newGrp );
  	if( listBoxItem ){
  	 	listGroup->setFocus();
  	 	listGroup->setCurrentItem( listBoxItem );
  	}
		selectGroupDesrc();
	}else{
   	listGroup->setCurrentItem( lastListPos );
	}
	delete kpgrp;
}


//opens the dialog for global options
 void Kpass::openOptions(){
  Kpopt *kpopt = new Kpopt();
	// this is to get the dialog started in center of the mainwidget
	getMainWinPos();	
	QPoint q( 29, 45 );
	mainWinPos += q;	
	kpopt->move ( mainWinPos );
  if(kpopt->exec() == QDialog::Accepted){
		pwdGeneratorValue = kpopt->getGeneratorValue();
		isPasswdChecked   = kpopt->getPasswdChecked();
		isInfoMsgChecked  = kpopt->getInfoMsgChecked();
  	isShowTipChecked  = kpopt->getShowTipChecked();
		isEncryptChecked  = kpopt->getEncryptChecked();
		isEditMaskChecked = kpopt->getEditMaskChecked();
		isBrowserChecked  = kpopt->getBrowserChecked();
		isBrowserLogin 		= kpopt->getIsBrowserLogin();
		isFtpLogin				=	kpopt->getIsFtpLogin();
		whatPassword      = kpopt->getPassword();
		progBrowserName   = kpopt->getBrowserName();
		progFtpName       = kpopt->getFtpName();		
		delete kpopt;
		setConfig();
		if(isPasswdChecked){
			if(isInfoMsgChecked){
  			KMessageBox::information(this, i18n( QString( "Remember your password!\n\n"
					"You selected a password for this\n"
					"program. Next time at start up\n"
					"you'll be ask for your password.") ) );		
			}
		}
		// save the data from dialog now
		setConfig();
	}
}


// opens the KDE config file (local) and fill the global vars
void Kpass::getConfig(){

		KGlobal::config()->setGroup("General options");

		isPasswdChecked = KGlobal::config()->readBoolEntry("isPasswdChecked");
		isInfoMsgChecked = KGlobal::config()->readBoolEntry("isInfoMsgChecked");
  	isShowTipChecked = KGlobal::config()->readBoolEntry("isShowTipChecked");
		isEncryptChecked = KGlobal::config()->readBoolEntry("isEncryptChecked");
		isEditMaskChecked = KGlobal::config()->readBoolEntry("isEditMaskChecked");
		isBrowserChecked = KGlobal::config()->readBoolEntry("isBrowserChecked");
		isBrowserLogin = KGlobal::config()->readBoolEntry("isBrowserLogin");
		isFtpLogin = KGlobal::config()->readBoolEntry("isFtpLogin");
		whatPassword = KGlobal::config()->readEntry("password");
		progBrowserName = KGlobal::config()->readEntry("progBrowserName");
		progFtpName = KGlobal::config()->readEntry("progFtpName");
		pwdGeneratorValue = KGlobal::config()->readNumEntry("pwdGeneratorValue");

}


// this puts the data back to KDE config file
// located in $HOME/.KDE2/share/config/kpassrc
void Kpass::setConfig(){

		KGlobal::config()->setGroup ("General options");
		KGlobal::config()->writeEntry ("pwdGeneratorValue", pwdGeneratorValue);
		KGlobal::config()->writeEntry ("isPasswdChecked", isPasswdChecked);
  	KGlobal::config()->writeEntry ("isInfoMsgChecked", isInfoMsgChecked);
  	KGlobal::config()->writeEntry ("isShowTipChecked", isShowTipChecked);
  	KGlobal::config()->writeEntry ("isEncryptChecked", isEncryptChecked);
  	KGlobal::config()->writeEntry ("isEditMaskChecked", isEditMaskChecked);
  	KGlobal::config()->writeEntry ("isBrowserChecked", isBrowserChecked);
  	KGlobal::config()->writeEntry ("isBrowserLogin", isBrowserLogin);
  	KGlobal::config()->writeEntry ("isFtpLogin", isFtpLogin);
  	KGlobal::config()->writeEntry ("password", whatPassword);
  	KGlobal::config()->writeEntry ("progBrowserName", progBrowserName);
  	KGlobal::config()->writeEntry ("progFtpName", progFtpName);

}	


// here i get the main groups from config file
void Kpass::setGroups(){
	// show data for groupListBox
	KConfig kconfig( filePath , false, false );
  QMap < QString, QString > myGroups =  kconfig.entryMap(groupConfMain);
	QMap < QString, QString >::Iterator it;
	QString passwordGroup;
	for (it = myGroups.begin(); it != myGroups.end(); ++it){
		QString key = (it.key() ).latin1();
		QString values = QString ( (*it).latin1() );
		listGroup->insertItem( key );	
	}
	listGroup->setCurrentItem(0);
	QString count;
	count.setNum(listGroup->count() );
	if( count == QString( "1" )  ){
  	lblGroup->setText( count+i18n( " Group" ) );
	}else{
  	lblGroup->setText( count+i18n( " Groups"  ) );
	}
}


// getting group description
void Kpass::selectGroupDesrc(){
	KConfig kconfig( filePath, false, false );
  QMap < QString, QString > myDescr =  kconfig.entryMap(groupConfMain);
	QMap < QString, QString >::Iterator itd;
	QString text = listGroup->currentText();
		
	for (itd = myDescr.begin(); itd != myDescr.end(); ++itd){
		QString key = (itd.key() ).latin1();
		QString values = QString ( (*itd).latin1() );

		if(QString(listGroup->currentText() ) == key){
    	txtGroup->setText( values );
			//QMessageBox::warning( 0, "File error", "key: " );
		}
	}
}


// show the data for passwordListBox on click in grouplistbox
void Kpass::groupSelected(){
	KConfig kconfig( filePath, false, false );
	QString text = listGroup->currentText();
  QMap < QString, QString > myPasswords =  kconfig.entryMap(text);
	QMap < QString, QString >::Iterator itp;
	listPasswordList->clear();  // clear the list	
	for (itp = myPasswords.begin(); itp != myPasswords.end(); ++itp){  // get new passwordlist
		QString key = (itp.key() ).latin1();
		QString values = QString ( (*itp).latin1() );
		listPasswordList->insertItem(key);
  }
	listPasswordList->sort(true);	
	QString count;
	count.setNum(listPasswordList->count() );
	if( count == QString( "1" ) ){
  	lblPasswordList->setText( count+i18n( " Password" ) );
	}else{
  	lblPasswordList->setText( count+i18n( " Passwords" ) );
	}
}


// this shows single items on click in password box
void Kpass::passwordSelected(){
	KConfig kconfig( filePath, false, false );
	QString groupText = listGroup->currentText();
	QString passwordText = listPasswordList->currentText();
  QMap < QString, QString > myItems =  kconfig.entryMap(groupText);
	QMap < QString, QString >::Iterator iti;
	for (iti = myItems.begin(); iti != myItems.end(); ++iti){
		QString key = (iti.key() ).latin1();
		QString values = QString ( (*iti).latin1() );	
	 	if(key == passwordText){
			QStringList myEntrys = QStringList::split("|",values);
			int i = 0;
			for ( QStringList::Iterator itq = myEntrys.begin(); itq != myEntrys.end(); ++itq ) {
				QString values = QString ( *itq );
				switch (i){
					case 0:
						// aarrghhhh  must have something to split
						if(values == "-"){values = "";}
						txtUserName->setText(values);
						break;
					case 1:
						if(values == "-"){values = "";}
  					txtPassword->setText(values);
						break;
					case 2:
						urlProtocol = values;
						break;
					case 3:
						if(values == "-"){values = "";}
						urlString = values;
						txtUrl->setText(urlProtocol+values);
						break;
					case 4:
  					lblDateCreated->setText( i18n( "Password created on:" ) );
						lblDate->setText(values);
						break;
					case 5:
						if(values == "-"){values = "";}
						txtMemo->setText(values);
						break;
					
					default:
						// should not apera in any case	
						QMessageBox::warning( 0, i18n(  "File error" ), i18n( "Please restart program." ) );			
  			}
				i++;
			}
		}
	}
}


// when getting new password list first i have to clear the old one
void Kpass::clearPasswords(){    // when click grouplist item
	txtUserName->setText("");
  txtPassword->setText("");
	txtUrl->setText("");
	txtMemo->setText("");
	lblDateCreated->setText("");
	lblDate->setText("");
}


// this handles the signal from forward button groups
void Kpass::forwardGroupList(){
  int a = listGroup->currentItem();
	listGroup->setCurrentItem( listGroup->currentItem() + 1 );
	int b = listGroup->currentItem();
	if(a == b){
		 listGroup->setCurrentItem( listGroup->firstItem() );
	}
}


// and this here is for the back button signal
void Kpass::backGroupList(){		
  int a = listGroup->currentItem();
	listGroup->setCurrentItem( listGroup->currentItem() - 1 );
	int b = listGroup->currentItem();
	if(a == b){
		int c = listGroup->count();
		listGroup->setCurrentItem( c-1 );
	}
}


// here is for passwordlist forward signal
void Kpass::forwardPasswordList(){
  int a = listPasswordList->currentItem();
	listPasswordList->setCurrentItem( listPasswordList->currentItem() + 1 );
	int b = listPasswordList->currentItem();
	if(a == b){
		 listPasswordList->setCurrentItem( listPasswordList->firstItem() );
	}
}


// here i handle the back button passwords
void Kpass::backPasswordList(){
  int a = listPasswordList->currentItem();
	listPasswordList->setCurrentItem( listPasswordList->currentItem() - 1 );
	int b = listPasswordList->currentItem();
	if(a == b){
		int c = listGroup->count();
		listPasswordList->setCurrentItem( c-1 );
	}
}


// delete a group item and all containing items and data
void Kpass::deleteGroupItem(){
	QString selectedItem = listGroup->currentText();
	int really = KMessageBox::warningContinueCancel(this, i18n(
		QString ("Do you really want to delete\nthis group item?\n\n"
							"'%1'\n\nAll of the contained Passwords will be deleted as well.\n"
							"There is no way to restore!\n\nDo you want to continue?" ).arg( selectedItem ) ),
							i18n( "warning!" ), i18n( "delete group" ) );
	if (really == KMessageBox::Continue){
    KSimpleConfig confs ( filePath );
		confs.setGroup ( selectedItem );
		confs.deleteGroup ( selectedItem );
		confs.setGroup( groupConfMain );
		confs.deleteEntry( selectedItem, false );
	}
	listGroup->clear();	
	setGroups();
	listGroup->setCurrentItem(0);
}


// this deletes a password item and all data
void Kpass::deletePasswordItem(){
	QString selectedItem = listPasswordList->currentText();
	if(selectedItem == 0){
		KMessageBox::information(this, i18n("No Item selected!") );
	}else{
		int really = KMessageBox::questionYesNo(this, i18n(
		QString( "Do you really want to delete\nthis password item?\n\n"
						 "'%1' \n\nThere is no way to restore!" ).arg(selectedItem) ) );
		if (really == KMessageBox::Yes){
    	KSimpleConfig conf ( filePath );
			conf.setGroup ( listGroup->currentText() );
			conf.deleteEntry ( listPasswordList->currentText(), false );
		}
		listPasswordList->clear();
		groupSelected();
		listPasswordList->setCurrentItem(0);
	}
}


// copy button for passwords
void Kpass::copyPassword(){
	QClipboard *cb = KApplication::clipboard();
	QString text = txtPassword->text();
  cb->setText( text );
	if(text == ""){
		KMessageBox::information(this, i18n( "Password copy:\n\nNothing to do!\nField is empty." ) );
	}else{
		if(isInfoMsgChecked){
			KMessageBox::information(this, i18n( QString( "Password copy:\n\n"
				"%1\nUse 'ctrl+v' or 'rightclick -> paste' to\npaste the string in"
				" an other application").arg( text ) ) );
		}
	}
}


// copy button for usernames
void Kpass::copyUserName(){
	QClipboard *cb = KApplication::clipboard();
	QString text = txtUserName->text();
  cb->setText( text );
	if(text == ""){
		KMessageBox::information(this, i18n( "Username copy:\n\nNothing to do!\nField is empty." ) );
	}else{
		if(isInfoMsgChecked){
			KMessageBox::information(this,  i18n( QString( "Username copy:\n\n"
				"%1\nUse 'ctrl+v' or 'rightclick -> paste' to\npaste the string in"
				" an other application").arg( text ) ) );
		}
	}
}


// copy button for the urls
void Kpass::copyUrl(){
	QClipboard *cb = KApplication::clipboard();
	QString text = txtUrl->text();
  cb->setText( text );
	if(text == ""){
		KMessageBox::information(this, i18n("Url copy:\n\nNothing to do!\nField is empty.") );
	}else{
		if(isInfoMsgChecked){
			KMessageBox::information(this,  i18n( QString( "Url copy:\n\n"
				"%1\nUse 'ctrl+v' or 'rightclick -> paste' to\npaste the string in"
				" an other application").arg( text) ) );
		}
	}
}


// copy button for the group description
void Kpass::copyGroupDescr(){
	QClipboard *cb = KApplication::clipboard();
	QString text = txtGroup->text();
  cb->setText( text );
	if(text == ""){
		KMessageBox::information(this, i18n("Group description copy:\n\nNothing to do!\nField is empty.") );
	}else{
		if(isInfoMsgChecked){
			KMessageBox::information(this,  i18n( QString( "Group description copy:\n\n"
				"%1\nUse 'ctrl+v' or 'rightclick -> paste' to\npaste the string in"
				" an other application").arg( text) ) );
		}
	}
}


// copy button for memo text
void Kpass::copyMemo(){
	QClipboard *cb = KApplication::clipboard();
	QString text = txtMemo->text();
  cb->setText( text );

	if(text == ""){
		KMessageBox::information(this, i18n("Memo copy:\n\nNothing to do!\nField is empty.") );
	}else{
		if(isInfoMsgChecked){
  		KMessageBox::information(this,  i18n( QString( "Memo copy:\n\n"
				"%1\nUse 'ctrl+v' or 'rightclick -> paste' to\npaste the string in"
				" an other application").arg( text) ) );
		}
	}
}


// here i start an external app and load the url
// via commandline even for non KDE programs :)
void Kpass::startWebApp(){
QString appl;
QString login;
QString url;
QString addArgs;;
KProcess *proc = new KProcess;
if(isBrowserLogin){
	login = txtUserName->text()+":"+txtPassword->text()+"@";
}else{
	login = "";
}
if(isFtpLogin){
	login = txtUserName->text()+":"+txtPassword->text()+"@";
}else{
	login = "";
}
if(urlProtocol == "ftp://"){
	url = "ftp://"+login+urlString;
  appl = progFtpName;
}else{
	url = urlProtocol+login+urlString;
	appl = progBrowserName;
}
(*proc) << appl << url ;
proc->start(KProcess::DontCare, KProcess::Stdout);
QApplication::beep();		
}


//KMessageBox::information(this, i18n("aufgerufen") );
void Kpass::passwordListDoubleClick(){
	if(isEditMaskChecked == true){
		openPwdMask(true);
	}else{
   	startWebApp();
	}	
}

// opens the group dialog
void Kpass::groupListDoubleClick(){
	openGrpMask(true);
}

// get the mainwidget position to start dialogs in center
void Kpass::getMainWinPos(){
	mainWinPos = Kpass::pos();
}



// End
////////////////////////////////////////////////////////////////////////////////


