/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) 2001 by Karl E. Maij
    email              : kem@sitedesign.ch
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.	See http://www.gnu.org		
****************************************************************************/

#include "kpgrp.h"
#include "kppics.h"

extern QString filePath;
extern QString groupConfMain;
extern bool isEdit;

Kpgrp::Kpgrp( QWidget* parent,  const char* name, WFlags fl ) : QDialog( parent, name, true, fl ){

    QPixmap image0( ( const char** ) image0_data );
    if ( !name )
		this->setFixedSize( 251, 207 );
    setCaption( i18n( "New Group Entry" ) );
    setIcon( image0 );

    // input box
    inputBox = new QGroupBox( this, "inputBox" );
    inputBox->setGeometry( QRect( 5, 5, 240, 155 ) );
    inputBox->setFrameShadow( QGroupBox::Plain );

    lblGroupname = new QLabel( inputBox, "lblGroupname" );
    lblGroupname->setGeometry( QRect( 10, 5, 220, 21 ) );
    lblGroupname->setText( i18n( "Group name" ) );

    txtGroupName = new QLineEdit( inputBox, "txtGroupName" );
    txtGroupName->setGeometry( QRect( 10, 25, 220, 22 ) );
  	txtGroupName->setFocus();

    lblDescription = new QLabel( inputBox, "lblDescription" );
    lblDescription->setGeometry( QRect( 10, 50, 221, 16 ) );
    lblDescription->setText( i18n( "Description" ) );

    txtDescription = new QMultiLineEdit( inputBox, "txtDescription" );
    txtDescription->setGeometry( QRect( 10, 70, 220, 71 ) );


    // button box
    buttonBox = new QGroupBox( this, "buttonBox" );
    buttonBox->setGeometry( QRect( 5, 165, 240, 35 ) );
    buttonBox->setFrameShadow( QGroupBox::Plain );

    cmdCreate = new QPushButton( buttonBox, "cmdCreate" );
    cmdCreate->setGeometry( QRect( 10, 6, 105, 22 ) );
    cmdCreate->setText( i18n( "Save" ) );
    cmdCreate->setAutoMask( TRUE );

    cmdCancel = new QPushButton( buttonBox, "cmdCancel" );
    cmdCancel->setGeometry( QRect( 125, 6, 105, 22 ) );
    cmdCancel->setText( i18n( "Cancel" ) );
    cmdCancel->setAutoMask( TRUE );

    connect( cmdCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
		connect( cmdCreate, SIGNAL( clicked() ), this, SLOT( checkGroup() ) );
}


void Kpgrp::setGroup( QString textGroup ){
	txtGroupName->setText( textGroup );
}


void Kpgrp::setDescription( QString textDescription ){
    txtDescription->setText( textDescription );
}

void Kpgrp::checkGroup(){
	int fileExists = false;
	KConfig kconfig( filePath , false, false );
 	QMap < QString, QString > myGroups =  kconfig.entryMap( groupConfMain );
	QMap < QString, QString >::Iterator it;
	for (it = myGroups.begin(); it != myGroups.end(); ++it){
		QString key = (it.key() ).latin1();
		QString values = QString ( (*it).latin1() );
		if( txtGroupName->text() == key){
			fileExists = true;
		}
	}
	if(fileExists & (isEdit == false)){	
		int really = KMessageBox::warningYesNo(this, i18n(
			QString( "Groupname exists!\n\n'%1'\nis already existing!\nSaving "
				"this group with the same\nname will delete the old group description\nbut "
				"NOT all included password data.\nGive a new groupname and description\n"
				"will only change the group description.\n\nDo you want to continue?" )
				.arg( txtGroupName->text() ) ) );
  	switch (really == KMessageBox::Yes){
			case (true):
				accept();
				break;
			case false:
				break;
			default:
				break;
    }
	}else{
		accept();
	}
}

Kpgrp::~Kpgrp(){
}
