/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) 2001 by Karl E. Maij
    email              : kem@sitedesign.ch
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.	See http://www.gnu.org		
****************************************************************************/

#ifndef KPOPT_H
#define KPOPT_H

#include <klocale.h>
#include <kglobal.h>
#include <kconfig.h>
#include <kdialog.h>
#include <kapp.h>

#include <qmessagebox.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qslider.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qvariant.h>
#include <qfiledialog.h>


class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QRadioButton;
class QSlider;
class QButtonGroup;


class Kpopt : public KDialog{

  Q_OBJECT

public:
  Kpopt( QWidget *parent = 0, const char *name = 0, WFlags fl = 0 );
  ~Kpopt();

	// Configure Box
  QGroupBox *ConfigBox;
  QCheckBox *cbTooltipps, *cbKrypt, *cbMessages;
	// Generator Box
  QGroupBox *GeneratorBox;
  QLabel *txtTick, *lblUnsecure, *lblSecure, *lblPasswordGenerator;
  QSlider *slGenerator;
	// Edit Box
  QGroupBox *EditBox;
  QLabel *lblListDoubleClick;
  QRadioButton *rbMask, *rbBrowser;
  //Programm Password Box
  QGroupBox *PasswordBox;
  QCheckBox *cbPasswordSecurity;
  QLineEdit *txtPassword;
  QLabel *lblPassword;
  QPushButton *cmdGenerator;
  // Application Box
  QGroupBox *AppBox;
  QLineEdit *txtBrowser, *txtFtp;
  QLabel *lblPathBrowser, *lblPathFtp;
  QPushButton *cmdFtp, *cmdBrowser;
	QCheckBox *cbFtpLogin, *cbBrowserLogin;
  // General Button Box
  QGroupBox *ButtonBox;
  QPushButton *cmdCancel, *cmdStandard, *cmdSave;

	// the stuff send to the mainWidow when options is accepted
 	int getGeneratorValue() const {return slGenerator->value();}
	bool getPasswdChecked() const {return cbPasswordSecurity->isChecked();}
	bool getInfoMsgChecked() const {return cbMessages->isChecked();}
  bool getShowTipChecked() const {return cbTooltipps->isChecked();}
	bool getEncryptChecked() const {return cbKrypt->isChecked();}
	bool getEditMaskChecked() const {return rbMask->isChecked();}
	bool getBrowserChecked() const {return rbBrowser->isChecked();}
	bool getIsBrowserLogin() const {return cbBrowserLogin->isChecked();}
	bool getIsFtpLogin() const {return cbFtpLogin->isChecked();}
	QString getPassword() const {return txtPassword->text();}
	QString getBrowserName() const {return txtBrowser->text();}
	QString getFtpName() const {return txtFtp->text();}

public slots:
	void findAppFtp();
	void findAppBrowser();
	void standardEntry();
	void pwdGenerator();
};

#endif // KPOPT_H

