/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) 2001 by Karl E. Maij
    email              : kem@sitedesign.ch
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.	See http://www.gnu.org		
****************************************************************************/

#include "kppwd.h"
#include "kppics.h"
#include "kppwd.moc"


static int groupItem = 0;
static int protocolItem = 0;
extern bool isEdit;

Kppwd::Kppwd( QWidget* parent,  const char* name, WFlags fl ) : KDialog( parent, name, true, fl ){

  QPixmap image0( ( const char** ) image0_data );
  setIcon( image0 );
  if ( !name )
	setName( "Kpeditpwd" );
	this->setFixedSize( 453, 304 );

	// inputBox
  inputBox = new QGroupBox( this, "inputBox" );
  inputBox->setGeometry( QRect( 5, 5, 443, 250 ) );
  inputBox->setFrameShadow( QGroupBox::Plain );

  cmdGenerator = new QPushButton( inputBox, "cmdGenerator" );
  cmdGenerator->setGeometry( QRect( 200, 168, 22, 22 ) );
  cmdGenerator->setPixmap( image0 );
  cmdGenerator->setFocusPolicy( QPushButton::TabFocus );
  QToolTip::add(  cmdGenerator, i18n( " Copy " ) );

  txtUserName = new QLineEdit( inputBox, "txtUserName" );
  txtUserName->setGeometry( QRect( 9, 119, 210, 22 ) );

  lblPassword = new QLabel( inputBox, "lblPassword" );
  lblPassword->setGeometry( QRect( 9, 150, 70, 16 ) );
  lblPassword->setFrameShadow( QLabel::MShadow );
  lblPassword->setFrameShape( QLabel::NoFrame );
  lblPassword->setText( i18n( "Password:" ) );

  lblMemo = new QLabel( inputBox, "lblMemo" );
  lblMemo->setGeometry( QRect( 228, 50, 70, 16 ) );
  lblMemo->setText( i18n( "Memo:" ) );

  txtMemo = new QMultiLineEdit( inputBox, "txtMemo" );
  txtMemo->setGeometry( QRect( 229, 70, 204, 120 ) );
  txtMemo->setWordWrap( QMultiLineEdit::WidgetWidth );
  txtMemo->setText( i18n( "" ) );

  lblUserName = new QLabel( inputBox, "lblUserName" );
  lblUserName->setGeometry( QRect( 9, 101, 136, 16 ) );
  lblUserName->setFrameShadow( QLabel::MShadow );
  lblUserName->setText( i18n( "Username:" ) );

  QString groupName;
  comboGroup = new QComboBox( false, inputBox, "comboGroup" );
	comboGroup->setGeometry( QRect( 9, 70, 210, 21 ) );

  txtUrl = new QLineEdit( inputBox, "txtUrl" );
  txtUrl->setGeometry( QRect( 75, 215, 359, 22 ) );

  lblGroup = new QLabel( inputBox, "lblGroup" );
  lblGroup->setGeometry( QRect( 9, 51, 70, 16 ) );
  lblGroup->setText( i18n( "Group:" ) );

  comboProtocol = new QComboBox( false, inputBox, "comboProtocol" );
  comboProtocol->setGeometry( QRect( 9, 215, 60, 22 ) );

  txtPassword = new QLineEdit( inputBox, "txtPassword" );
  txtPassword->setGeometry( QRect( 9, 168, 181, 22 ) );

  lblUrl = new QLabel( inputBox, "lblUrl" );
  lblUrl->setGeometry( QRect( 9, 196, 85, 16 ) );
  lblUrl->setText( i18n( "Webaddress:" ) );

  txtDescription = new QLineEdit( inputBox, "txtDescription" );
  txtDescription->setGeometry( QRect( 9, 25, 424, 22 ) );
  txtDescription->setFocus();

  lblDescription = new QLabel( inputBox, "lblDescription" );
  lblDescription->setGeometry( QRect( 9, 4, 201, 21 ) );
  lblDescription->setText( i18n( "Description line" ) );

	//button box
  buttonBox = new QGroupBox( this, "buttonBox" );
  buttonBox->setGeometry( QRect( 5, 260, 443, 36 ) );
  buttonBox->setFrameShadow( QGroupBox::Plain );
  buttonBox->setFrameShape( QGroupBox::Box );

  cmdSave = new QPushButton( buttonBox, "cmdSave" );
  cmdSave->setGeometry( QRect( 9, 7, 207, 22 ) );
  cmdSave->setText( i18n( "Save" ) );
  cmdSave->setAutoMask( true );
  QToolTip::add(  cmdSave, i18n( QString::fromUtf8( "Save your new Entry" ) ) );
	cmdSave->setDefault( true );

  cmdCancel = new QPushButton( buttonBox, "cmdCancel" );
  cmdCancel->setGeometry( QRect( 227, 7, 207, 22 ) );
  cmdCancel->setText( i18n( "Cancel" ) );
  cmdCancel->setAutoMask( true );
	

  // tab order
  setTabOrder( txtDescription, comboGroup );
  setTabOrder( comboGroup, txtUserName );
  setTabOrder( txtUserName, txtPassword );
  setTabOrder( txtPassword, cmdGenerator );
  setTabOrder( cmdGenerator, comboProtocol );
  setTabOrder( comboProtocol,txtUrl  );
  setTabOrder( txtUrl, txtMemo );
  setTabOrder( txtMemo, cmdSave );
  setTabOrder( cmdSave, cmdCancel );

  connect( cmdCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
	connect( cmdSave, SIGNAL( clicked() ), this, SLOT( checkDescription() ) );
	connect( cmdGenerator, SIGNAL( clicked() ), this, SLOT( pwdGenerator() ) );
}


// set the values for existing password to edit
void Kppwd::setGroup(QString groupText){
	 txtUrl->setText( groupText );	
}


void Kppwd::setComboProtocol(QString txtProtocol){
	comboProtocol->insertItem( txtProtocol );	
	protocolItem = comboProtocol->count();	
}


void Kppwd::setComboProtocolItem(){
	comboProtocol->setCurrentItem( protocolItem-1 );
	protocolItem = 0;	
}


void Kppwd::setDescription(QString textDescription){
	txtDescription->setText( textDescription );	
}


void Kppwd::setComboGroup(QString textCombo){
	comboGroup->insertItem( textCombo );	
	groupItem = comboGroup->count();
}


void Kppwd::setComboGroupItem(){
	comboGroup->setCurrentItem( groupItem-1 );
	groupItem = 0;	
}


void Kppwd::setTxtPassword(QString textPassword){
	txtPassword->setText( textPassword );	
}


void Kppwd::setTxtUserName(QString textUserName){
	txtUserName->setText( textUserName );	
}


void Kppwd::setTxtUrl(QString textUrl){
	txtUrl->setText( textUrl );	
}


void Kppwd::setTxtMemo(QString textMemo){
	txtMemo->setText( textMemo );	
}

// checks if an existing entry exists
void Kppwd::checkDescription(){
	int fileExists = false;
	KConfig kconfig( filePath , false, false );
 	QMap < QString, QString > myGroups =  kconfig.entryMap( comboGroup->currentText() );
	QMap < QString, QString >::Iterator it;
	for (it = myGroups.begin(); it != myGroups.end(); ++it){
		QString key = (it.key() ).latin1();
		QString values = QString ( (*it).latin1() );

		if( ( txtDescription->text() == key ) & ( isEdit == false ) ){
			fileExists = true;
		}
	}
	if(fileExists){	
		int really = KMessageBox::warningYesNo(this,
			QString( "Password entry exists!\n\n'%1'\nis already existing!\nSaving this password with "
			"the same\nname will delete the old item\nGive a new entryname or move\nthe password "
			"to another group.\n\nDo you really want to delete\nthe existing password?")
			.arg(txtDescription->text() ) );
  	switch (really == KMessageBox::Yes){
			case (true):
				accept();
				break;
			case false:
				break;
			default:
				break;
    }
	}else{
		accept();
	}
}

// the password generator
void Kppwd::pwdGenerator(){

	QString string =  KApplication::randomString( pwdGeneratorValue+1 );
	string.remove(0,1);
	txtPassword->setText( string );
}


Kppwd::~Kppwd(){}
