/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) |2001| by |Karl E. Maij|
    email              : |kem@sitedesign.ch|
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    Files to this program:
    kppics.h, kpass.h, kpopt.h, kppwd.h, kpgrp.h, kpout.h
    kpass.cpp, kpopt.cpp, kppwd.cpp, kpgrp.cpp, kpout.cpp
    kpass  = mainwidget
    kpopt  = option dialog
    kgrp   = group dialog
    kppwd  = password dialog
    kpout  = print & backup dialogs
		kppics = ASCII pics for kpass

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.			
****************************************************************************/

#include "kpass.h"
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include <kapp.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <kglobal.h>
#include <kconfig.h>
#include <kpassdlg.h>



static const char *description = I18N_NOOP("Kpass");		
static KCmdLineOptions options[] = {{ 0, 0, 0 }};

int main(int argc, char **argv){
	// let's go
  KAboutData aboutData( "kpass", "Kpass",
    "0.012" , description, KAboutData::License_GPL,
    "(c) 2001, by Karl E. Maij");
  aboutData.addAuthor("Karl E. Maij",0, "kem@sitedesign.ch");
  KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options );
  KUniqueApplication::addCmdLineOptions();
	// get the app just once running
	if (!KUniqueApplication::start()) {
		KApplication app;
    KMessageBox::information( 0, I18N_NOOP( "Ooops,\nKpass is already running" ) );
		exit(0);
	}
	KUniqueApplication app;

	// get conf data to check if passworddialog needed
	KGlobal::config()->setGroup("General options");
	int isPasswdChecked = KGlobal::config()->readBoolEntry("isPasswdChecked");
	QString whatPassword = KGlobal::config()->readEntry("password");

	// password dialog 1 chance
	QCString password;
	if(isPasswdChecked){
		int result = KPasswordDialog::getPassword(password, i18n( "Password" ));
  	if (result == KPasswordDialog::Accepted){
			if(QString( password ) == whatPassword){
				Kpass *top = new Kpass();
  			top->show();
  			return app.exec();
	  	}else{
				app.quit();
			}
		}
	// no password needed
	}else{
		Kpass *top = new Kpass();
  	top->show();
  	return app.exec();
	}
}
